con
  _clkmode = xtal1 + pll16x      'set to ext low speed crystal
  _xinfreq = 5_000_000

e_to_2 = 1.44269504088896

obj

  S : "parallax serial terminal" 'serial communications with the host.  
  F32 : "F32_1_6_pre"           'single cog assembly floating point lib
  Fe : "floatmathextended"      'My upgrade to FloatMath to include Log, (exp?) (and optionally Sin, Cos, Tan and inverses)
  Fi : "Float32Full"            'two cog assembly floating point lib
  Q : "spin_trigpack_log"       'fixed point Qs15.16 math library.
  Fs : "FloatString"            'conversion utilities between strings and floats

var

  byte  str_buf[100]

pub main | temp, temp_float, temp_Qv, temp2, mid_float, mid_Qv
'' do nothing for now

  'start the serial port
  S.start(115200)

  'start F32
  F32.start

  'start Float32Full
  Fi.start

  'initialise FloatMathExtended
  'nop

  'initialise fixed point math lib
  Q.start_driver


  'wait for PST to get focus
  waitcnt( cnt + clkfreq*3)
  S.str(string("Testing different math libraries" ))
  S.char(S#NL)

  S.str(String("Type in a posative integer to compare Log2 results (enter a negative value to end this step)"))
  S.char(S#NL)

  repeat
    S.str(String("type a value: "))
    S.StrInMax(@str_buf,99)
    S.Str(@str_buf)
    temp_float := Fs.StringToFloat(@str_buf)
    temp_Qv := Q.StrToQval(@str_buf)
    'temp := S.decIn             'get an integer
    'S.dec(temp)
    'if temp < 0
    '  quit
    'temp_float := F32.FFloat(temp)
    'temp_Qv := Q.Qval(temp)
    S.char(S#TB)

    S.str(String("F32: "))
    mid_float := F32.Log2(temp_float)
    S.str(Fs.FloatToString(mid_float))
    S.str(string(" inv: "))
    S.str(Fs.FloatToString(F32.Exp2(mid_float)))
    S.char(S#TB)

    S.str(String("Float32Full: "))
    temp2 := Fi.log(temp_float)
    temp2 := Fi.Fmul(temp2,e_to_2) 'convert to a base 2 logarithm 
    S.str(Fs.FloatToString(temp2))
    S.char(S#TB)
    
    S.str(string("fixed_point: "))
    mid_Qv := Q.QLog2(temp_QV)
    S.str(Q.QvalToStr(mid_Qv))
    S.str(string(" and inverse: "))
    S.str(Q.QvalToStr(Q.QAlog2(mid_QV)))
    S.char(S#NL)

  
   